// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// JoinChat 用户或机器人主动加入群聊。
//
// 注意事项:
// - 应用需要开启[机器人能力](https://open.feishu.cn/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-enable-bot-ability)
// - 目前仅支持加入公开群
// - 操作内部群时, 操作者须与群组在同一租户下
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/chat-members/me_join
func (r *ChatService) JoinChat(ctx context.Context, request *JoinChatReq, options ...MethodOptionFunc) (*JoinChatResp, *Response, error) {
	if r.cli.mock.mockChatJoinChat != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Chat#JoinChat mock enable")
		return r.cli.mock.mockChatJoinChat(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Chat",
		API:                   "JoinChat",
		Method:                "PATCH",
		URL:                   r.cli.openBaseURL + "/open-apis/im/v1/chats/:chat_id/members/me_join",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(joinChatResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockChatJoinChat mock ChatJoinChat method
func (r *Mock) MockChatJoinChat(f func(ctx context.Context, request *JoinChatReq, options ...MethodOptionFunc) (*JoinChatResp, *Response, error)) {
	r.mockChatJoinChat = f
}

// UnMockChatJoinChat un-mock ChatJoinChat method
func (r *Mock) UnMockChatJoinChat() {
	r.mockChatJoinChat = nil
}

// JoinChatReq ...
type JoinChatReq struct {
	ChatID string `path:"chat_id" json:"-"` // 群 ID, 详情参见[群ID 说明](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/chat-id-description), 注意: 仅支持公开（Public）群类型, 对于已认证企业的飞书的群人数默认上限: 普通群5000人, 会议群3000人, 话题群5000人, 示例值: "oc_a0553eda9014c201e6969b478895c230"
}

// JoinChatResp ...
type JoinChatResp struct {
}

// joinChatResp ...
type joinChatResp struct {
	Code int64         `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string        `json:"msg,omitempty"`  // 错误描述
	Data *JoinChatResp `json:"data,omitempty"`
}
