// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// CreateSpreadsheet 在指定目录下创建表格
//
// doc: https://open.feishu.cn/document/ukTMukTMukTM/uUDN04SN0QjL1QDN/sheets-v3/spreadsheet/create
func (r *DriveService) CreateSpreadsheet(ctx context.Context, request *CreateSpreadsheetReq, options ...MethodOptionFunc) (*CreateSpreadsheetResp, *Response, error) {
	if r.cli.mock.mockDriveCreateSpreadsheet != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Drive#CreateSpreadsheet mock enable")
		return r.cli.mock.mockDriveCreateSpreadsheet(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Drive",
		API:                   "CreateSpreadsheet",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/sheets/v3/spreadsheets",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(createSpreadsheetResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockDriveCreateSpreadsheet mock DriveCreateSpreadsheet method
func (r *Mock) MockDriveCreateSpreadsheet(f func(ctx context.Context, request *CreateSpreadsheetReq, options ...MethodOptionFunc) (*CreateSpreadsheetResp, *Response, error)) {
	r.mockDriveCreateSpreadsheet = f
}

// UnMockDriveCreateSpreadsheet un-mock DriveCreateSpreadsheet method
func (r *Mock) UnMockDriveCreateSpreadsheet() {
	r.mockDriveCreateSpreadsheet = nil
}

// CreateSpreadsheetReq ...
type CreateSpreadsheetReq struct {
	Title       *string `json:"title,omitempty"`        // 表格标题, 示例值: "title", 长度范围: `0` ～ `255` 字符
	FolderToken *string `json:"folder_token,omitempty"` // 文件夹token, 获取方式见[如何获取云文档资源相关 token](https://open.feishu.cn/document/ukTMukTMukTM/uczNzUjL3czM14yN3MTN), 示例值: "fldcnMsNb*hIW9IjG1LVswg"
}

// CreateSpreadsheetResp ...
type CreateSpreadsheetResp struct {
	Spreadsheet *CreateSpreadsheetRespSpreadsheet `json:"spreadsheet,omitempty"` // 表格
}

// CreateSpreadsheetRespSpreadsheet ...
type CreateSpreadsheetRespSpreadsheet struct {
	Title            string `json:"title,omitempty"`             // 表格标题
	FolderToken      string `json:"folder_token,omitempty"`      // 文件夹token, 获取方式见[如何获取云文档资源相关 token](https://open.feishu.cn/document/ukTMukTMukTM/uczNzUjL3czM14yN3MTN)
	URL              string `json:"url,omitempty"`               // 文档url
	SpreadSheetToken string `json:"spreadsheet_token,omitempty"` // 表格token
}

// createSpreadsheetResp ...
type createSpreadsheetResp struct {
	Code int64                  `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                 `json:"msg,omitempty"`  // 错误描述
	Data *CreateSpreadsheetResp `json:"data,omitempty"`
}
