// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2ApplicationApplicationFeedbackCreatedV6 当应用收到新反馈时, 触发该事件{使用示例}(url=/api/tools/api_explore/api_explore_config?project=application&version=v6&resource=application.feedback&event=created)
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/application-v6/application-feedback/events/created
func (r *EventCallbackService) HandlerEventV2ApplicationApplicationFeedbackCreatedV6(f EventV2ApplicationApplicationFeedbackCreatedV6Handler) {
	r.cli.eventHandler.eventV2ApplicationApplicationFeedbackCreatedV6Handler = f
}

// EventV2ApplicationApplicationFeedbackCreatedV6Handler event EventV2ApplicationApplicationFeedbackCreatedV6 handler
type EventV2ApplicationApplicationFeedbackCreatedV6Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2ApplicationApplicationFeedbackCreatedV6) (string, error)

// EventV2ApplicationApplicationFeedbackCreatedV6 ...
type EventV2ApplicationApplicationFeedbackCreatedV6 struct {
	UserID       *EventV2ApplicationApplicationFeedbackCreatedV6UserID `json:"user_id,omitempty"`       // 用户 ID
	AppID        string                                                `json:"app_id,omitempty"`        // 被反馈应用 ID
	FeedbackTime string                                                `json:"feedback_time,omitempty"` // 反馈提交时间, 格式为yyyy-mm-dd hh:mm:ss
	TenantName   string                                                `json:"tenant_name,omitempty"`   // 反馈用户的租户名
	FeedbackType int64                                                 `json:"feedback_type,omitempty"` // 反馈类型（枚举值, 1: 故障反馈, 2: 产品建议）
	FaultType    []int64                                               `json:"fault_type,omitempty"`    // 故障类型列表: 1: 黑屏 2: 白屏 3: 无法打开小程序  4: 卡顿 5: 小程序闪退 6: 页面加载慢 7: 死机 8: 其他异常
	FaultTime    string                                                `json:"fault_time,omitempty"`    // 故障时间, 格式为yyyy-mm-dd hh:mm:ss
	Source       int64                                                 `json:"source,omitempty"`        // 反馈来源: 1: 小程序 2: 网页应用 3: 机器人 4: webSDK
	Contact      string                                                `json:"contact,omitempty"`       // 用户填写的联系方式, 字段权限要求（满足任一）: 获取用户邮箱信息, 获取用户手机号
	Description  string                                                `json:"description,omitempty"`   // 反馈详情
	Images       []string                                              `json:"images,omitempty"`        // 反馈图片url列表, url 过期时间三天
	FeedbackID   string                                                `json:"feedback_id,omitempty"`   // 应用反馈 ID, 应用反馈记录唯一标识
	FeedbackPath string                                                `json:"feedback_path,omitempty"` // 反馈页面路径
}

// EventV2ApplicationApplicationFeedbackCreatedV6UserID ...
type EventV2ApplicationApplicationFeedbackCreatedV6UserID struct {
	UnionID string `json:"union_id,omitempty"` // 用户的 union id
	UserID  string `json:"user_id,omitempty"`  // 用户的 user id, 字段权限要求: 获取用户 user ID
	OpenID  string `json:"open_id,omitempty"`  // 用户的 open id
}
