// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2AttendanceUserTaskUpdatedV1 了解事件订阅的使用场景和配置流程, 请点击查看 [事件订阅概述](https://open.feishu.cn/document/ukTMukTMukTM/uUTNz4SN1MjL1UzM)
//
// 事件
// 当用户任务变更后, 推送该用户的任务状态变更消息。
// 事件体
// |名称|类型|描述|
// |---|---|---|
// |schema|string|事件模式|
// |header|event_header|事件头|
// |-event_id|string|事件 ID|
// |-event_type|string|事件类型|
// |-create_time|string|事件创建时间戳（单位: 毫秒）|
// |-token|string|事件 Token|
// |-app_id|string|应用 ID|
// |-tenant_key|string|租户 Key|
// |event|-|事件体|
// |-employee_id|string|员工 ID|
// |-employee_no|string|员工工号|
// |-group_id|string|考勤组 ID|
// |-shift_id|string|班次 ID|
// |-date|int|日期|
// |-status_changes|list|状态变更数组|
// |--before_status|string|变更前打卡结果, 值为: 【NoNeedCheck（无需打卡）, SystemCheck（系统打卡）, Normal（正常）, Early（早退）, Late（迟到）, Lack（缺卡）】|
// |--current_status|string|变更后打卡结果, 值为: 【NoNeedCheck（无需打卡）, SystemCheck（系统打卡）, Normal（正常）, Early（早退）, Late（迟到）, Lack（缺卡）】|
// |--before_supplement|string|变更前结果补充, 值为: 【None（无）, ManagerModification（管理员修改）, CardReplacement（补卡通过）, ShiftChange（换班）, Travel（出差）, Leave（请假）, GoOut（外出）, CardReplacementApplication（补卡申请中）, FieldPunch（外勤打卡）】|
// |--current_supplement|string|变更后打卡结果补充, 值为: 【None（无）, ManagerModification（管理员修改）, CardReplacement（补卡通过）, ShiftChange（换班）, Travel（出差）, Leave（请假）, GoOut（外出）, CardReplacementApplication（补卡申请中）, FieldPunch（外勤打卡）】|
// |--work_type|string|上下班状态变更, 值为: 【on（上班）, off（下班）】
// |--index|string|任务中的第几次上下班
// 事件示例
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/attendance-v1/event/user-task-status-change-event
func (r *EventCallbackService) HandlerEventV2AttendanceUserTaskUpdatedV1(f EventV2AttendanceUserTaskUpdatedV1Handler) {
	r.cli.eventHandler.eventV2AttendanceUserTaskUpdatedV1Handler = f
}

// EventV2AttendanceUserTaskUpdatedV1Handler event EventV2AttendanceUserTaskUpdatedV1 handler
type EventV2AttendanceUserTaskUpdatedV1Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2AttendanceUserTaskUpdatedV1) (string, error)

// EventV2AttendanceUserTaskUpdatedV1 ...
type EventV2AttendanceUserTaskUpdatedV1 struct {
}
