// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2TaskTaskUpdatedV1 当 APP 订阅此事件后可以接收到由该 APP 创建的任务发生的变更, 包括任务标题、描述、截止时间、协作者、关注者、提醒时间、状态（完成或取消完成）。{使用示例}(url=/api/tools/api_explore/api_explore_config?project=task&version=v1&resource=task&event=updated)
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/task-v1/task/events/updated
func (r *EventCallbackService) HandlerEventV2TaskTaskUpdatedV1(f EventV2TaskTaskUpdatedV1Handler) {
	r.cli.eventHandler.eventV2TaskTaskUpdatedV1Handler = f
}

// EventV2TaskTaskUpdatedV1Handler event EventV2TaskTaskUpdatedV1 handler
type EventV2TaskTaskUpdatedV1Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2TaskTaskUpdatedV1) (string, error)

// EventV2TaskTaskUpdatedV1 ...
type EventV2TaskTaskUpdatedV1 struct {
	TaskID  string `json:"task_id,omitempty"`  // 任务ID
	ObjType int64  `json:"obj_type,omitempty"` // 通知类型（1: 任务详情发生变化, 2: 任务协作者发生变化, 3: 任务关注者发生变化, 4: 任务提醒时间发生变化, 5: 任务完成, 6: 任务取消完成, 7: 任务删除）
}
