// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// UpdateTaskComment 该接口用于更新评论内容
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/task-v1/task-comment/update
func (r *TaskService) UpdateTaskComment(ctx context.Context, request *UpdateTaskCommentReq, options ...MethodOptionFunc) (*UpdateTaskCommentResp, *Response, error) {
	if r.cli.mock.mockTaskUpdateTaskComment != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Task#UpdateTaskComment mock enable")
		return r.cli.mock.mockTaskUpdateTaskComment(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Task",
		API:                   "UpdateTaskComment",
		Method:                "PUT",
		URL:                   r.cli.openBaseURL + "/open-apis/task/v1/tasks/:task_id/comments/:comment_id",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(updateTaskCommentResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockTaskUpdateTaskComment mock TaskUpdateTaskComment method
func (r *Mock) MockTaskUpdateTaskComment(f func(ctx context.Context, request *UpdateTaskCommentReq, options ...MethodOptionFunc) (*UpdateTaskCommentResp, *Response, error)) {
	r.mockTaskUpdateTaskComment = f
}

// UnMockTaskUpdateTaskComment un-mock TaskUpdateTaskComment method
func (r *Mock) UnMockTaskUpdateTaskComment() {
	r.mockTaskUpdateTaskComment = nil
}

// UpdateTaskCommentReq ...
type UpdateTaskCommentReq struct {
	TaskID      string  `path:"task_id" json:"-"`       // 任务ID, 示例值: "83912691-2e43-47fc-94a4-d512e03984fa"
	CommentID   string  `path:"comment_id" json:"-"`    // 评论 ID, 示例值: "6937231762296684564"
	Content     *string `json:"content,omitempty"`      // 新的评论内容, 示例值: "飞流直下三千尺, 疑是银河落九天", 长度范围: `0` ～ `65536` 字符
	RichContent *string `json:"rich_content,omitempty"` // 新的富文本评论内容（优先使用）, 示例值: "飞流直下三千尺, 疑是银河落九天<at id=7058204817822318612></at>", 长度范围: `0` ～ `65536` 字符
}

// UpdateTaskCommentResp ...
type UpdateTaskCommentResp struct {
	Comment *UpdateTaskCommentRespComment `json:"comment,omitempty"` // 返回修改后的任务评论详情
}

// UpdateTaskCommentRespComment ...
type UpdateTaskCommentRespComment struct {
	Content         string `json:"content,omitempty"`           // 评论内容, <md-alert>, 评论内容和富文本评论内容同时存在时只使用富文本评论内容, </md-alert>
	ParentID        string `json:"parent_id,omitempty"`         // 评论的父ID, 创建评论时若不为空则为某条评论的回复, 若为空则不是回复
	ID              string `json:"id,omitempty"`                // 评论ID, 由飞书服务器发号
	CreateMilliTime string `json:"create_milli_time,omitempty"` // 评论创建的时间戳, 单位为毫秒, 用于展示, 创建时不用填写
	RichContent     string `json:"rich_content,omitempty"`      // 富文本评论内容。语法格式参见[Markdown模块](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/task-v1/markdown-module)
}

// updateTaskCommentResp ...
type updateTaskCommentResp struct {
	Code int64                  `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                 `json:"msg,omitempty"`  // 错误描述
	Data *UpdateTaskCommentResp `json:"data,omitempty"`
}
