// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// BatchGetVCRoomLevel 该接口可以使用会议室层级ID批量查询会议室层级详情
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/vc-v1/room_level/mget
func (r *VCService) BatchGetVCRoomLevel(ctx context.Context, request *BatchGetVCRoomLevelReq, options ...MethodOptionFunc) (*BatchGetVCRoomLevelResp, *Response, error) {
	if r.cli.mock.mockVCBatchGetVCRoomLevel != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] VC#BatchGetVCRoomLevel mock enable")
		return r.cli.mock.mockVCBatchGetVCRoomLevel(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "VC",
		API:                   "BatchGetVCRoomLevel",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/vc/v1/room_levels/mget",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(batchGetVCRoomLevelResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockVCBatchGetVCRoomLevel mock VCBatchGetVCRoomLevel method
func (r *Mock) MockVCBatchGetVCRoomLevel(f func(ctx context.Context, request *BatchGetVCRoomLevelReq, options ...MethodOptionFunc) (*BatchGetVCRoomLevelResp, *Response, error)) {
	r.mockVCBatchGetVCRoomLevel = f
}

// UnMockVCBatchGetVCRoomLevel un-mock VCBatchGetVCRoomLevel method
func (r *Mock) UnMockVCBatchGetVCRoomLevel() {
	r.mockVCBatchGetVCRoomLevel = nil
}

// BatchGetVCRoomLevelReq ...
type BatchGetVCRoomLevelReq struct {
	LevelIDs []string `json:"level_ids,omitempty"` // 层级ID列表, 示例值: ["omb_4ad1a2c7a2fbc5fc9570f38456931293"]
}

// BatchGetVCRoomLevelResp ...
type BatchGetVCRoomLevelResp struct {
	Items []*BatchGetVCRoomLevelRespItem `json:"items,omitempty"` // 会议室层级列表
}

// BatchGetVCRoomLevelRespItem ...
type BatchGetVCRoomLevelRespItem struct {
	RoomLevelID   string   `json:"room_level_id,omitempty"`   // 层级ID
	Name          string   `json:"name,omitempty"`            // 层级名称
	ParentID      string   `json:"parent_id,omitempty"`       // 父层级ID
	Path          []string `json:"path,omitempty"`            // 层级路径
	HasChild      bool     `json:"has_child,omitempty"`       // 是否有子层级
	CustomGroupID string   `json:"custom_group_id,omitempty"` // 自定义层级ID
}

// batchGetVCRoomLevelResp ...
type batchGetVCRoomLevelResp struct {
	Code int64                    `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                   `json:"msg,omitempty"`  // 错误描述
	Data *BatchGetVCRoomLevelResp `json:"data,omitempty"`
}
